/* $Header: /usr2/brugere/jbln/uc133/src/RCS/config.c,v 1.4 1995/03/06 23:18:47 jbln Exp jbln $ */

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>

#include "uc.h"
#include "cfgfile.h"

static int cfg_version = 0;

#define CURNUM 1
char *currentnames[CURNUM] =
   {"version"};


/************************************************************
   CONFIGURATION FILE
************************************************************/

config_setup()
{
   FILE *ifile, *ofile;
   CFGDATA *cfg;
   int n,num;
   char fname[200], cmd[200];

   prefvals[PREFEDITOR] = strdup(DEF_EDITOR);
   prefvals[PREFVIEWER] = strdup(DEF_VIEWER);
   prefvals[PREFSAVEHIST] = strdup(DEF_SAVEHIST);
   prefvals[PREFSHELL] = strdup(DEF_SHELL);

   for (n=0 ; n<CONFIGNUM ; n++)
      configvals[n] = (char *)malloc(200);

   sprintf(fname, "%s/.uccfg", (char *)getenv("HOME"));
   if ( (ifile=fopen(fname, "r")) == NULL )
   {
      if (!DEF_CFGFILEEXT)
      {
         if ( (ofile=fopen(fname, "w")) == NULL )
	    return(0);
         config_create_intcfg(ofile);  /* Write standard cfg. */
         fclose(ofile);
      }
      else
      {
	 sprintf(cmd, "cp %s %s", DEF_CFGFILENAME, fname);
	 system(cmd);
      }

      if ( (ifile=fopen(fname, "r")) == NULL )
      {
	 printf("Unable to open/create file: %s\n", fname);
	 getchar();
	 return(0);
      }
   }
   fclose(ifile);

   if ( (cfg=cfg_readfile(fname, &num)) == (CFGDATA *)NULL)
      return(0);

   for (n=0 ; n<num ; n++)
   {
      if (strcmp(cfg[n].header, "associations") == 0)
	 config_assoc(&cfg[n]);
      else
      if (strcmp(cfg[n].header, "diralias") == 0)
	 config_dalias(&cfg[n]);
      else
      if (strcmp(cfg[n].header, "userkeys") == 0)
	 config_userkeys(&cfg[n]);
      else
      if (strcmp(cfg[n].header, "terminal") == 0)
	 config_terminal(&cfg[n]);
      else
      if (strcmp(cfg[n].header, "terminfo") == 0)
	 ti_setup(&cfg[n]);
      else
      if (strcmp(cfg[n].header, "leftwin") == 0)
	 config_win(&cfg[n], 0);
      else
      if (strcmp(cfg[n].header, "rightwin") == 0)
	 config_win(&cfg[n], 1);
      else
      if (strcmp(cfg[n].header, "preferences") == 0)
	 config_pref(&cfg[n]);
      else
      if (strcmp(cfg[n].header, "current") == 0)
	 config_cur(&cfg[n]);
      else
      if (strcmp(cfg[n].header, "history") == 0)
	 config_history(&cfg[n]);
   }

   cfg_clear(cfg, num);

   if (VERSION > cfg_version)
   {
      config_show_news();
      cfg_version = VERSION;
   }

   return(1);
}


config_assoc(cfg)
CFGDATA *cfg;
{
   int n;

   fassoc = (ASSOC *)malloc(sizeof(ASSOC) * cfg->datanum);

   for (n=0 ; n<cfg->datanum ; n++)
   {
      fassoc[n].mask = strdup(cfg->data[n].id);
      fassoc[n].command = strdup(cfg->data[n].val);
   }
   assoc_num = cfg->datanum;
}


config_dalias(cfg)
CFGDATA *cfg;
{
   int n;

   diralias = (ASSOC *)malloc(sizeof(ASSOC) * cfg->datanum);

   for (n=0 ; n<cfg->datanum ; n++)
   {
      diralias[n].mask = strdup(cfg->data[n].id);
      diralias[n].command = strdup(cfg->data[n].val);
   }
   daliasnum = cfg->datanum;
}


config_userkeys(cfg)
CFGDATA *cfg;
{
   int n;
   int key;
   char id, *p;

   for (n=0 ; n<cfg->datanum ; n++)
   {
      id = cfg->data[n].id[0];
      key = -1;
      if (id >= 'A'  &&  id < 'A'+UKNUM)
	 key = id - 'A';
      else
      if (id >= 'a'  &&  id < 'a'+UKNUM)
	 key = id - 'a';

      if (key != -1)
      {
	 if (userkeys[key] != NULL)
	    free(userkeys[key]);
	 userkeys[key] = strdup(cfg->data[n].val);
      }
   }
}


config_terminal(cfg)
CFGDATA *cfg;
{
   int n;

   for (n=0 ; n<cfg->datanum ; n++)
   {
      if (strcmp(cfg->data[n].id, "up") == 0)
	 terminal.up = atoi(cfg->data[n].val);
      else
      if (strcmp(cfg->data[n].id, "down") == 0)
	 terminal.down = atoi(cfg->data[n].val);
      else
      if (strcmp(cfg->data[n].id, "left") == 0)
	 terminal.left = atoi(cfg->data[n].val);
      else
      if (strcmp(cfg->data[n].id, "right") == 0)
	 terminal.right = atoi(cfg->data[n].val);
      else
      if (strcmp(cfg->data[n].id, "enter") == 0)
	 terminal.enter = atoi(cfg->data[n].val);
      else
      if (strcmp(cfg->data[n].id, "pageup") == 0)
	 terminal.pageup = atoi(cfg->data[n].val);
      else
      if (strcmp(cfg->data[n].id, "pagedown") == 0)
	 terminal.pagedown = atoi(cfg->data[n].val);
      else
      if (strcmp(cfg->data[n].id, "backspace") == 0)
	 terminal.backspace = atoi(cfg->data[n].val);
   }
}


config_win(cfg, pos)
CFGDATA *cfg;
int pos;
{
   int n;

   for (n=0 ; n<cfg->datanum ; n++)
   {
      if (strcmp(cfg->data[n].id,"showhidden") == 0)
         uc[pos].showhidden = atoi(cfg->data[n].val);
      else
      if (strcmp(cfg->data[n].id,"sorting") == 0)
         uc[pos].sorting = atoi(cfg->data[n].val);
      else
      if (strcmp(cfg->data[n].id,"showmode") == 0)
         uc[pos].showmode = atoi(cfg->data[n].val);
      else
      if (strcmp(cfg->data[n].id,"size") == 0)
         uc[pos].size = atoi(cfg->data[n].val);
   }

   if (uc[pos].size == 0)
   {
      if (uc[pos].showmode == SHOWWIDE)
	 uc[pos].size = 8;
      if (uc[pos].showmode == SHOWNORM)
	 uc[pos].size = 16;
   }
}


config_pref(cfg)
CFGDATA *cfg;
{
   int n,m;

   for (n=0 ; n<cfg->datanum ; n++)
   {
      for (m=0 ; m<PREFNUM ; m++)
      {
	 if (strcmp(cfg->data[n].id, prefnames[m]) == 0)
	 {
	    free(prefvals[m]);
	    prefvals[m] = strdup(cfg->data[n].val);
	 }
      }
   }
}


config_cur(cfg)
CFGDATA *cfg;
{
   int n;
   
   for (n=0 ; n<cfg->datanum ; n++)
   {
      if (strcmp(cfg->data[n].id, "version")==0)
	 cfg_version = atoi(cfg->data[n].val);
   }
}


config_history(cfg)
CFGDATA *cfg;
{
   int n;
   int pos;

   for (n=0 ; n<cfg->datanum ; n++)
   {
      if ((pos=atoi(cfg->data[n].id)) > 0  &&  pos <= HISTORY)
      {
         strncpy(command_stack[pos-1], cfg->data[n].val, 200);
         command_stack[pos][200] = 0;  /* Safety */
      }
      else
      if (strcmp(cfg->data[n].id, "front") == 0)
      {
         cstack_front = atoi(cfg->data[n].val);
      }
      else
      if (strcmp(cfg->data[n].id, "back") == 0)
      {
         cstack_back = atoi(cfg->data[n].val);
      }
      else
      if (strcmp(cfg->data[n].id, "cur") == 0)
      {
         cstack_cur = atoi(cfg->data[n].val);
      }
   }
}


config_history_update(fname)
char *fname;
{
   char *vals[HISTORY+3], *ids[HISTORY+3];
   char front[20], back[20], cur[20];
   int n;

   for (n=0 ; n<HISTORY ; n++)
   {
      ids[n] = malloc(20);
      sprintf(ids[n], "%d", n+1);
      vals[n] = command_stack[n];
   }

   ids[HISTORY] = strdup("front");
   ids[HISTORY+1] = strdup("back");
   ids[HISTORY+2] = strdup("cur");
   sprintf(front, "%d", cstack_front);
   sprintf(back, "%d", cstack_back);
   sprintf(cur, "%d", cstack_cur);
   vals[HISTORY] = front;
   vals[HISTORY+1] = back;
   vals[HISTORY+2] = cur;

   cfg_update(fname, "history", ids, vals, HISTORY+3);

   for (n=0 ; n<HISTORY ; n++)
      free(ids[n]);

}


config_close()
{
   int n;
   char fname[200];

   sprintf(fname, "%s/.uccfg", (char *)getenv("HOME"));

   for (n=0 ; n<assoc_num ; n++)
   {
      free(fassoc[n].mask);
      free(fassoc[n].command);
   }
   if (assoc_num > 0)
      free(fassoc);
   assoc_num = 0;

   for (n=0 ; n<daliasnum ; n++)
   {
      free(diralias[n].mask);
      free(diralias[n].command);
   }
   if (daliasnum > 0)
      free(diralias);
   daliasnum = 0;

   for (n=0 ; n<UKNUM ; n++)
      if (userkeys[n] != NULL)
      {
	 free(userkeys[n]);
	 userkeys[n] = NULL;
      }

   sprintf(configvals[0], "%d", terminal.up);
   sprintf(configvals[1], "%d", terminal.down);
   sprintf(configvals[2], "%d", terminal.left);
   sprintf(configvals[3], "%d", terminal.right);
   sprintf(configvals[4], "%d", terminal.enter);
   sprintf(configvals[5], "%d", terminal.pageup);
   sprintf(configvals[6], "%d", terminal.pagedown);
   sprintf(configvals[7], "%d", terminal.backspace);

   cfg_update(fname, "terminal", termnames, configvals, TERMKEYNUM);

   sprintf(configvals[0], "%d", uc[0].showhidden);
   sprintf(configvals[1], "%d", uc[0].sorting);
   sprintf(configvals[2], "%d", uc[0].showmode);
   sprintf(configvals[3], "%d", uc[0].size);

   cfg_update(fname, "leftwin", screennames, configvals, SCREENNUM);

   sprintf(configvals[0], "%d", uc[1].showhidden);
   sprintf(configvals[1], "%d", uc[1].sorting);
   sprintf(configvals[2], "%d", uc[1].showmode);
   sprintf(configvals[3], "%d", uc[1].size);

   cfg_update(fname, "rightwin", screennames, configvals, SCREENNUM);

   sprintf(configvals[0], "%d", cfg_version);
   cfg_update(fname, "current", currentnames, configvals, CURNUM);

   if (atoi(prefvals[PREFSAVEHIST]))
      config_history_update(fname);
   free(prefvals[PREFEDITOR]); 
   free(prefvals[PREFVIEWER]);
   free(prefvals[PREFSHELL]);
   free(prefvals[PREFSAVEHIST]);

   for (n=0 ; n<CONFIGNUM ; n++)
      free(configvals[n]);
}


config_create_intcfg(ofile)
FILE *ofile;
{
   config_new_help();

   fprintf(ofile, "; You should not change [*win], [current] and [terminal] !\n");
   fprintf(ofile, "; The rest may be changed at your own will\n\n");

   fprintf(ofile, "; ===[ FILE ASSOCIATION ]=============================================\n");
   fprintf(ofile, ";  Defined macros are:\n");
   fprintf(ofile, ";     !    = Filename without extension (filename.tar.Z -> filename)\n");
   fprintf(ofile, ";     !.!  = Filename with extension\n");
   fprintf(ofile, ";     !/   = Current working directory\n");
   fprintf(ofile, ";     !!   = !\n");
   fprintf(ofile, ";     !w   = Wait for keypress after execution\n");
   fprintf(ofile, ";     !{prompt}\n");
   fprintf(ofile, ";          = Output \"prompt\", substitute with user input\n");
   fprintf(ofile, ";     !(envvar)\n");
   fprintf(ofile, ";          = Get enviroment variable\n");
   fprintf(ofile, "; ====================================================================\n");
   fprintf(ofile, "\n");
   fprintf(ofile, "[associations]\n");
   fprintf(ofile, "*.c   = vi !.!\n");
   fprintf(ofile, "*.h   = vi !.!\n");
   fprintf(ofile, "*.txt = pg !.!\n");
   fprintf(ofile, "*.doc = pg !.!\n");
   fprintf(ofile, "*.Z   = uncompress !.!\n");
   fprintf(ofile, "*.zoo = zoo -l !.! | more !w\n");
   fprintf(ofile, "*.zip = unzip -l !.! | more !w\n");
   fprintf(ofile, "*.tar = tar -tvf !.! | more !w\n");
   fprintf(ofile, ".uccfg = vi !.!\n");

   fprintf(ofile, "\n\n; User keys uses the same macros as associations.\n");
   fprintf(ofile, "[userkeys]\n");
   fprintf(ofile, "o = vi !.!\n");

   fprintf(ofile, "\n\n[diralias]\n");
   fprintf(ofile, "bin = /usr/local/bin\n");

   fprintf(ofile, "\n\n[current]\n");
   fprintf(ofile, "version = %d\n\n\n", VERSION);

   fprintf(ofile, "; You MUST include some cmdline parameter in \"shell\" to\n");
   fprintf(ofile, "; define that you want the rest of the cmdline to be interpreted\n");
   fprintf(ofile, "; as a command\n");
   fprintf(ofile, "[preferences]\n");
   fprintf(ofile, "editor = %s\n", DEF_EDITOR);
   fprintf(ofile, "viewer = %s\n", DEF_VIEWER);
   fprintf(ofile, "shell = %s\n", DEF_SHELL);
   fprintf(ofile, "savehistory = %s\n", DEF_SAVEHIST);
}


config_new_help()
{
   cfg_version = VERSION;

   printf("\n\n\n");
   printf("===========================================================================\n");
   printf("   It looks like this is the first time you try The Unix Commander ...\n");
   printf("   - That is very nice of you, and I do hope you find some use\n");
   printf("     of this program\n");
   printf("\n   Before you start, you must know three things:\n\n");
   printf("      - Your normal function keys probably won't work, so you have\n");
   printf("        to use PF1 or ESC followed by 1,2,3..0 to simulate the F1-F10 keys\n");
   printf("      - Use PF1 or ESC followed by 'H' to get online help\n");
   printf("      - Uc uses a configuration file called '.uccfg' in your home directory\n");
   printf("\n\n   I guess that was all  :-)\n\n");
   printf("         Jorn Lind-Nielsen  / jbln@duroc.ds-data.dk\n\n");
   printf("   [press enter]\n");
   printf("===========================================================================\n");
   getchar();
}


config_show_news()
{
   printf("\n\n");
   printf("===========================================================================\n");
   printf("   Hey - You got a new uc version - great!\n");
   printf("\n   Let me tell you what news there are:\n\n");
   printf("      o  Bugs fixed: Did not load all userkeys.\n");
   printf("                     Reallocation error in hypertextviewer\n");
   printf("      o  Added support for all those hopeless terminals.\n");
   printf("      o  Added commandline editing, using key left and right.\n");
   printf("      o  Changed makefile to something better (hopefully!)\n");
   printf("      o  View full directory tree (alfa version)\n");
   printf("      o  User definable shell\n");
   printf("      o  Better filefind\n");
   printf("      o  !{prompt} and !(envvar) substitutes\n");
   printf("      o  F2-F10 support\n");
   printf("      o  Filemasks like '[abd]' is recognized\n");
   printf("      o  You may copy grouped files to names containing filemasks\n");
   printf("      o  Chown and chmod works on grouped files to.\n");
   printf("\n   I guess that was all  :-)\n");
   printf("         Jorn Lind-Nielsen  / jbln@duroc.ds-data.dk\n\n");
   printf("   [press enter]\n");
   printf("===========================================================================\n");
   getchar();
}
